<?php

/*
  Plugin Name: Besteron Payment Gateway
  Plugin URI: https://www.besteron.sk/
  Description: Extends WooCommerce by Adding the Besteon Payment Gateway. Dôležité: Aktiváciou pluginu na svojej stránke beriete na vedomie, že používanie pluginu je bez akejkoľvek záruky a autor pluginu, distribútor ani platobná brána neberú zodpovednosť za akékoľvek škody, ktoré používaním pluginu môžu nastať.
  Version: 1.2.7.
  Author: BESTERON
  Author URI: https://www.besteron.sk/
*/
 
/*  Copyright (C) 2022 NARATIVE (email: info@narative.sk)

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

*/ 

// Include our Gateway Class and register Payment Gateway with WooCommerce
add_action('plugins_loaded', 'besteron_payment_init', 0);

function besteron_payment_init() {
 //return;
    // If the parent WC_Payment_Gateway class doesn't exist
    // it means WooCommerce is not installed on the site
    // so do nothing
    if (!class_exists('WC_Payment_Gateway')) {
        return;
    }

    /**
     * Localisation
     */
    load_plugin_textdomain('besteron-payment-gateway', false, dirname(plugin_basename(__FILE__)) . '/languages');

    // If we made it this far, then include our Gateway Class
    include_once( 'class-wc-besteron-payment-gateway.php' );

    // Now that we have successfully included our class,
    // Lets add it too WooCommerce
    add_filter('woocommerce_payment_gateways', 'add_besteron_payment_gateway');

    function add_besteron_payment_gateway($methods) {
        $methods[] = 'WC_Besteron_Payment_Gateway';
        return $methods;
    }

}

// Note: not use, vall shop-iframe in js
// add_action( 'woocommerce_before_checkout_form', 'add_besteron_iframe_parent', 12 );
function add_besteron_iframe_parent(){
    echo '<div id="shop-iframe"></div>';
//    echo '<div class="shop-iframe-parent"><div class="close-besteron-window">Close</div><div id="shop-iframe"></div></div>';
}


// Add custom action links
add_filter('plugin_action_links_' . plugin_basename(__FILE__), 'besteron_payment_action_links');

function besteron_payment_action_links($links) {
    $plugin_links = array(
        '<a href="' . admin_url('admin.php?page=wc-settings&tab=checkout') . '">' . __('Settings', 'besteron-payment-gateway') . '</a>',
    );

    // Merge our new link with the default ones
    return array_merge($plugin_links, $links);
}


//Use version 2.0 of the update checker.
/*
require 'plugin-updates/plugin-update-checker.php';
$MyUpdateChecker = new PluginUpdateChecker_2_0 (
    'https://developer.besteron.sk/extensions/wordpress/woocomerce/metadata.json',
    __FILE__,
    "besteron"
);
*/