<?php

class Besteron {

    //const urls
    const BESTERON_URL = 'https://gate.besteron.com/api/payment-intent';
    const BESTERON_URL_TEST = 'http://client.besteron.com/public/virtual-payment/request/';
    const BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL = 'http://client.besteron.com/public/payments-gateways-generator/';

    //config parametrs
    const PARAM_BESTERON_URL = 'PARAM_BESTERON_URL';
    const PARAM_BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL = 'BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL';
    const PARAM_DEMO_MODE = 'DEMO';
    const PARAM_CID = 'CID';
    const PARAM_KEY = 'KEY';
    const PARAM_VS = 'VS';
    const PARAM_TYPE = 'TYPE'; //or BIC/SWIFT
    const PARAM_CURR = 'CURR';
    const PARAM_RU = 'RU';
    const PARAM_AMNT = 'AMNT';
    const APPLE = 'yes';

    const PARAM_RESULT = 'RESULT';
    const PARAM_SIGN = 'SIGN';
    const GATEWAY_LANGUAGE = 'SK';
    const PARAM_EMAIL = 'EMAIL';
    const PARAM_LANG = 'LANG';
    const PARAM_PAYMENT_TYPE = 'PAYMENT_TYPE';
    const PARAM_INLINE_PAYMENT_TYPE = 'INLINE_PAYMENT_TYPE';
    const BESTERON_AUTH_URL = 'https://gate.besteron.com/api/oauth2/token';

    //response
    const RESULT_OK = 'OK';
    const RESULT_FAIL = 'RESULT_FAIL';

    //currency
    const CURR_EURO = '978';

    //language default
    const LANG_DEFAULT = 'sk';
    
    // payment type default
    const PAYMENT_TYPE_DEFAULT = 'redirect';

    // inline payment type default
    const INLINE_PAYMENT_TYPE_DEFAULT = 'CARD';

    // inline payment type default
    const INLINE_PAYMENT_BANKS_DEFAULT = 'SK';

    const ADDITIONAL_PARAM_VALUE = "";

    const ADDITIONAL_PARAM_NAME = "";

    const VALIDITY_TIME = "3600";

    // possible suport banks
    // each country has its own CID/KEY for payment
    // for inline payment
    public static function getSupportBanksPossible() {
        return array(
            'SK' => array(
                'name' => __( 'Slovakia', 'besteron-payment-gateway' ),
                'curr' => '978',
            ),
            'CZ' => array(
                'name' => __( 'Czech Republic', 'besteron-payment-gateway' ),
                'curr' => '203',
            ),
        );
    }

    // only simple list with name - for settings
    public static function getSupportBanksList() {
        $banks_list['auto'] = __( 'Use site currency', 'besteron-payment-gateway' );
        foreach (Besteron::getSupportBanksPossible() as $key => $bank) {
            $banks_list[$key] = $key . ' - ' . $bank['name'];
        }
        return $banks_list;
    }

    public static function getArrayOfBanks($allows, $enabled_card, $support_banks, $enabled_bank_buttons, $allow_curr, $apple,$inline){
        
      
        if($inline == 'CARD'){

            $thebanks = Besteron::getAllowBanks($allows, $enabled_card, $support_banks, $enabled_bank_buttons, $allow_curr, $apple);

           
            $banks = [];
            foreach ($thebanks as $ar => $value) {
                if($ar == 'SPOROCARD'){
                    $ar = 'CARD';
                }
                $banks[] = $ar;
            }
            return $banks;
        }
    }
    

    /**
     * Set payment type.
     * @param string $lang
     * @return Besteron
     */
    public function setPaymentType($PAYMENT_TYPE) {
        $this->PAYMENT_TYPE = $PAYMENT_TYPE;
        return $this;
    }

    // get list payment type
    public static function getPaymentTypeList() {
        return array(
            'inline' => __( 'Inline on page', 'besteron-payment-gateway' ),
            'redirect' => __( 'Redirection', 'besteron-payment-gateway' )
        );
    }

    /**
     * Set inline payment type.
     * @param string $lang
     * @return Besteron
     */
    public function setInlinePaymentType($INLINE_PAYMENT_TYPE) {
        $this->INLINE_PAYMENT_TYPE = $INLINE_PAYMENT_TYPE;
        return $this;
    }

    // list of inline payment type
    public static function getInlinePaymentTypeList() {
        return array(
            'CARD' => __( 'Credit Card only', 'besteron-payment-gateway' ),
            'CARDANDBUTTON' => __( 'Credit Card & Banks Buttons', 'besteron-payment-gateway' )
        );
    }


    // support SK banks list
     public static $BANKS = array(
        'GIBASKBX' => array(
            'code' => '0900',
            'name' => 'Slovenská sporiteľňa, a. s.',
            'image' => 'slsp',
            'label' => 'SporoPay',
            'curr' => '978',
            'support' => 'SK',
        ),
        'TATRSKBX' => array(
            'code' => '1100',
            'name' => 'Tatra banka, a. s.',
            'image' => 'tatra',
            'label' => 'TatraPay',
            'curr' => '978',
            'support' => 'SK',
        ),
        'SUBASKBX' => array(
            'code' => '0200',
            'name' => 'Všeobecná úverová banka, a. s.',
            'image' => 'vub',
            'label' => 'ePlatby VÚB',
            'curr' => '978',
            'support' => 'SK',
        ),
        'UNCRSKBX' => array(
            'code' => '1111',
            'name' => 'UniCredit Bank',
            'image' => 'unicredit',
            'label' => 'UniPlatba',
            'curr' => '978',
            'support' => 'SK',
        ),
        'POBNSKBA' => array(
            'code' => '6500',
            'name' => 'Poštová banka, a. s.',
            'image' => 'pb',
            'label' => 'Platba Online',
            'curr' => '978',
            'support' => 'SK',
        ),
        'VIAMO' => array(
            'code' => '',
            'name' => 'VIAMO',
            'image' => 'viamo',
            'label' => 'VIAMO',
            'curr' => '978',
            'support' => 'SK',
        )
    );

    // support CZ banks list
  public static $BANKS_CZ = array(
        'RZBCCZPP' => array(
            'code' => '',
            'name' => 'Raiffeisenbank a.s.',
            'image' => 'raiffeisen',
            'label' => 'Raiffeisen',
            'curr' => '203',
            'support' => 'CZ',
       ),
        'GIBACZPX' => array(
            'code' => '',
            'name' => 'Česká spořitelna, a.s.',
            'image' => 'csp',
            'label' => 'Česká spořitelna',
            'curr' => '203',
            'support' => 'CZ',
        ),
        'KOMBCZPP' => array(
            'code' => '',
            'name' => 'KB – Komerční banka, a.s.',
            'image' => 'kb',
            'label' => 'KB – Komerční banka',
            'curr' => '203',
            'support' => 'CZ',
        ),
        'BREXCZPP' => array(
            'code' => '',
            'name' => 'mBank',
            'image' => 'mbank',
            'label' => 'mBank',
            'curr' => '203',
            'support' => 'CZ',
        ),
        'AGBACZPP' => array(
            'code' => '',
            'name' => 'MONETA Money Bank, a. s.',
            'image' => 'moneta',
            'label' => 'MONETA Money Bank',
            'curr' => '203',
            'support' => 'CZ',
        ),
        'FIOBCZPP' => array(
            'code' => '',
            'name' => 'Fio banka, a.s.',
            'image' => 'fio',
            'label' => 'Fio banka',
            'curr' => '203',
            'support' => 'CZ',
        ),
        'BACXCZPP' => array(
            'code' => '',
            'name' => 'UniCredit Bank Czech Republic, a.s.',
            'image' => 'unicredit',
            'label' => 'UniCredit Bank Czech Republic',
            'curr' => '203',
            'support' => 'CZ',
        )
    );

    // support credit cards
    public static $BANKS_CARDS = array(
        'SPOROCARD' => array(
            'code' => '0900',
            'name' => 'Card payment',
            'image' => 'visamaster',
            'label' => 'Card payment',
            'curr' => '',
            'support' => '',
        )
    );

    public static $APPLEPAY = array(
        'APPLEPAY' => array(
            'code' => '',
            'name' => 'Apple Pay',
            'image' => 'apple',
            'label' =>'Apple Pay',
            'curr' => '',
            'support' => '',
        ),
         'GOOGLEPAY' => array(
            'code' => '',
            'name' => 'Google Pay',
            'image' => 'google',
            'label' =>'Google Pay',
            'curr' => '',
            'support' => '',
        )
    );

    // get banks buttons to array (for settings select)
    public static function getBanks($support_banks) {
        $banks = array();
        if ( in_array('SK', $support_banks) ) {
            foreach (Besteron::$BANKS as $bic => $bank) {
                $banks[$bic] = $bank['name'].' (SK)';
            }
        }
        if ( in_array('CZ', $support_banks) ) {
            foreach (Besteron::$BANKS_CZ as $bic => $bank) {
                $banks[$bic] = $bank['name'].' (CZ)';
            }
        }
        return $banks;
    }

    // get allowed banks and credit card for payment view
    public static function getAllowBanks($allows, $enabled_card, $support_banks, $enabled_bank_buttons, $allow_curr, $apple) {
        $banks = array();

        if ( $enabled_bank_buttons ) {

            if ( in_array('SK', $support_banks) ) $banks = Besteron::$BANKS;
            if ( in_array('CZ', $support_banks) ) $banks = $banks + Besteron::$BANKS_CZ;
            if ( !empty($allows) ) {
                // unset not allows banks
                foreach ($banks as $bic => $bank) {
                    if ( !in_array($bic, $allows) ) { unset($banks[$bic]); }
                }
            }
            if ( $allow_curr != '' ) {
                // only banks for allow currency
                foreach ($banks as $bic => $bank) {
                    if ( $bank['curr'] != $allow_curr ) { unset($banks[$bic]); }
                }
            }

        }
        if ( $enabled_card ) {
            // add to list credit cards
            $banks = Besteron::$BANKS_CARDS + $banks;
            $banks = Besteron::$APPLEPAY + $banks;
            

        }

        return $banks;
    }


    // get allowed banks and credit card for payment view
    public static function getAllowedBanks($allows, $enabled_card, $support_banks, $enabled_bank_buttons, $allow_curr, $apple,$inline_payment_type) {

        if($inline_payment_type == 'CARD'){
            return [];
        }
        $banks = array();

        if ( $enabled_bank_buttons ) {

            if ( in_array('SK', $support_banks) ) $banks = Besteron::$BANKS;
            if ( in_array('CZ', $support_banks) ) $banks = $banks + Besteron::$BANKS_CZ;
            if ( !empty($allows) ) {
                // unset not allows banks
                foreach ($banks as $bic => $bank) {
                    if ( !in_array($bic, $allows) ) { unset($banks[$bic]); }
                }
            }
            if ( $allow_curr != '' ) {
                // only banks for allow currency
                foreach ($banks as $bic => $bank) {
                    if ( $bank['curr'] != $allow_curr ) { unset($banks[$bic]); }
                }
            }

        }
        if ( $enabled_card ) {
            // add to list credit cards
            $banks = Besteron::$BANKS_CARDS + $banks;

        }

        return $banks;
    }



    /**
     * Unique Besteron customer ID. Required.
     * @var String
     */
    protected $CID;

    protected $APPLE;

    /**
     * Private key to crypt communication. Required.
     * @var String
     */
    protected $KEY;

    /**
     * Besteron url.
     * @var String
     */
    protected $BESTERON_URL;

    /**
     * Besteron payments gateways generator url.
     * @var String
     */
    protected $BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL;

    /**
     * Amount. Max 13+2 numbers. Decimal point ".". Required.
     * @var Float
     */
    protected $AMNT;

    /**
     * Variable symbol. Max 10 numbers. Required.
     * @var String
     */
    protected $VS;

    /**
     * Payment type TYPE
     * @var String
     */
    protected $TYPE;

    /**
     * Currency code
     * @var Int[3]
     */
    protected $CURR;

    /**
     * Language code
     * @var String
     */
    protected $LANG;

    public function __construct($cfg = array()) {

        if (!array_key_exists(self::PARAM_BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL, $cfg)) {
            $cfg[self::PARAM_BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL] = self::BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL;
        }
        if (!array_key_exists(self::PARAM_BESTERON_URL, $cfg) || array_key_exists(self::PARAM_DEMO_MODE, $cfg)) {
            $cfg[self::PARAM_BESTERON_URL] = $cfg[self::PARAM_DEMO_MODE]
                    ? self::BESTERON_URL_TEST : self::BESTERON_URL;
        }
        if (empty($cfg[self::PARAM_CID]) || empty($cfg[self::PARAM_KEY]) || empty($cfg[self::PARAM_BESTERON_URL]) || empty($cfg[self::PARAM_BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL])) {
            throw new Exception('Nastavte premenné v configu.');
        }
        $this->APPLE = $cfg[self::APPLE];
        $this->CID = $cfg[self::PARAM_CID];
        $this->BESTERON_URL = $cfg[self::PARAM_BESTERON_URL];
        $this->BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL = $cfg[self::PARAM_BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL];
        $this->KEY = $cfg[self::PARAM_KEY];
    }

    /**
     * Get amount.
     * @return string
     */
    public function getAmnt() {
        return $this->AMNT;
    }

    /**
     * Set amount.
     * @param string $amnt
     * @return Besteron
     */
    public function setAmnt($AMNT) {
        $this->AMNT = $this->sanitizeAmnt($AMNT);
        return $this;
    }

    /**
     * Set language.
     * @param string $lang
     * @return Besteron
     */
    public function setLang($LANG) {
        $this->LANG = $LANG;
        return $this;
    }

    // list of language
    public static function getLangList() {
        return array(
            'wp_auto' => __( 'Use site language', 'besteron-payment-gateway' ),
            'sk' => __( 'Slovak', 'besteron-payment-gateway' ),
            'cs' => __( 'Czech', 'besteron-payment-gateway' ),
            'hu' => __( 'Hungarian', 'besteron-payment-gateway' ),
            'pl' => __( 'Polish', 'besteron-payment-gateway' ),
            'ro' => __( 'Romanian', 'besteron-payment-gateway' ),
            'en' => __( 'English', 'besteron-payment-gateway' ),
            'de' => __( 'German', 'besteron-payment-gateway' ),
            'sl' => __( 'Slovenian', 'besteron-payment-gateway' )
        );
    }

    // possible language
    public static function getLangPossible() {
        return array( 'sk', 'cz', 'hu', 'pl', 'ro', 'en', 'de' );
    }

    // list of currency
    public static function getCurrList() {
        return array(
            '978' => 'EUR',
            '203' => 'CZK',
            '840' => 'USD',
            '826' => 'GBP',
            '348' => 'HUF',
            '985' => 'PLN',
            '756' => 'CHF',
            '208' => 'DKK',
            '980' => 'UAH',
            '946' => 'RON',
            '807' => 'MKD',
            '975' => 'BGN',
            '191' => 'HRK',
            '977' => 'BAM',
            '352' => 'ISK',
            '941' => 'RSD'
        );
    }

    // possible currency
    public static function getCurrPossible() {
        return array(978, 203, 840, 826, 348, 985, 756, 208, 980, 946, 807, 975, 191, 977, 352, 941);
    }

    /**
     * Get currency.
     * @return string
     */
    public function getCurr() {
        $curList = $this->getCurrList();

        return $curList[$this->CURR];
    }

    /**
     * Set currency.
     * @param string $curr
     * @return Besteron
     */
    public function setCurr($CURR) {
        $this->CURR = $CURR;
        return $this;
    }

    /**
     * Get variable symbol.
     * @return string
     */
    public function getVs() {
        return $this->VS;
    }

    /**
     * Set variable symbol.
     * @param string $vs
     * @return Besteron
     */
    public function setVs($VS) {
        $this->VS = $VS;
        return $this;
    }

    /**
     * Return sign.
     * @return string
     */
    public function generateSign($str) {
        $key = $this->KEY;
        $sha1hash = sha1($str);
        $hexSha1_16 = substr($sha1hash, 0, 32);
        $method = 'aes-256-ecb';
        $key = pack('H*', $key);
        $ivSize = openssl_cipher_iv_length($method);
    if ( $ivSize == 0 ) {
        $ivSize == 16;
            $iv = $ivSize;
    } else {
        $iv = openssl_random_pseudo_bytes($ivSize);
    }
        $data = pack('H*', $hexSha1_16);
        $result = openssl_encrypt($data, $method, $key, OPENSSL_RAW_DATA | OPENSSL_ZERO_PADDING, $iv);
        return strtoupper(bin2hex($result));
    }

    protected function sanitizeAmnt($AMNT) {

        return str_replace(',', '.', sprintf('%.2f', $AMNT));
    }

}

class BesteronRequest extends Besteron {

    /**
     * Return url. Required
     * @var String
     */
    protected $RU;

    /**
     * Customer e-mail. REQUIRED.
     * @var String
     */
    protected $EMAIL;

    protected $VALIDITY_TIME;

    protected $ADDITIONAL_PARAM_NAME;

    protected $ADDITIONAL_PARAM_VALUE;

    /**
     * @return Besteron
     */
    public function __construct($options = array(), $cfgPath = '') {

        parent::__construct($options, $cfgPath);

        if (!isset($options[self::PARAM_AMNT])) {
            throw new Exception('Amount is not defined.');
        }
        if (empty($options[self::PARAM_AMNT])) {
            throw new Exception('Amount is empty.');
        }
        if (!is_int($options[self::PARAM_AMNT]) && !is_float($options[self::PARAM_AMNT])) {
            throw new Exception('Amount is not a number.');
        }
        if (preg_match("/^\d+(\.\d{1,2})?$/", $options[self::PARAM_AMNT]) == 0) {
            throw new Exception('Amount format is not valid.');
        }
        if (!isset($options[self::PARAM_CURR])) {
            throw new Exception('Currency is not defined.');
        }
        if (empty($options[self::PARAM_CURR])) {
            throw new Exception('Currency is empty.');
        }
        if (!isset($options[self::PARAM_VS])) {
            throw new Exception('VariableSymbol is not defined.');
        }
        if (empty($options[self::PARAM_VS])) {
            throw new Exception('VariableSymbol is empty.');
        }
        if (!is_numeric($options[self::PARAM_VS])) {
            throw new Exception('VariableSymbol is not numeric.');
        }
        if (strlen($options[self::PARAM_VS]) > 10) {
            throw new Exception('VariableSymbol max length is 10.');
        }
        if (!isset($options[self::PARAM_RU])) {
            throw new Exception('ReturnUrl is not defined.');
        }
        if (empty($options[self::PARAM_RU])) {
            throw new Exception('ReturnUrl is empty.');
        }
        if (!isset($options[self::PARAM_CURR])) {
            throw new Exception('Currency is not defined.');
        }
        if (empty($options[self::PARAM_CURR])) {
            throw new Exception('Currency is empty.');
        }
        if(!isset($options[self::PARAM_EMAIL])) {
            throw new Exception('Customer e-mail is not defined.');
        }
        if(empty($options[self::PARAM_EMAIL])) {
            throw new Exception('Customer e-mail is empty.');
        }
        $this->setAmnt($options[self::PARAM_AMNT]);
        $this->setCurr($options[self::PARAM_CURR]);
        $this->setVs($options[self::PARAM_VS]);
        $this->setRu($options[self::PARAM_RU]);
        $this->setEmail($options[self::PARAM_EMAIL]);
        $this->setLang($options[self::PARAM_LANG]);
        $this->setAdditionalParamName($options[self::ADDITIONAL_PARAM_NAME]);
        $this->setAdditionalParamValue($options[self::ADDITIONAL_PARAM_VALUE]);
        $this->setValidityTime($options[self::VALIDITY_TIME]);
        $this->setPaymentType($options[self::PARAM_PAYMENT_TYPE]);
        $this->setInlinePaymentType($options[self::PARAM_INLINE_PAYMENT_TYPE]);

        return $this;
    }

    /**
     * Return return url.
     * @return string
     */
    public function getRu() {

        return $this->RU;
    }


    public function getValidityTime() {

        return $this->VALIDITY_TIME;
    }

    public function setValidityTime($VALIDITY_TIME){
        $this->VALIDITY_TIME = $VALIDITY_TIME;
        return $this;
    }

    public function getAdditionalParamName() {

        return $this->ADDITIONAL_PARAM_NAME;
    }

    public function setAdditionalParamName($ADDITIONAL_PARAM_NAME){
        $this->ADDITIONAL_PARAM_NAME = $ADDITIONAL_PARAM_NAME;
        return $this;
    }

    public function getAdditionalParamValue() {

        return $this->ADDITIONAL_PARAM_VALUE;
    }

    public function setAdditionalParamValue($ADDITIONAL_PARAM_VALUE){
        $this->ADDITIONAL_PARAM_VALUE = $ADDITIONAL_PARAM_VALUE;
        return $this;
    }

    /**
     * Set return url.
     * @param string $returnUrl
     * @return Besteron
     */
    public function setRu($RU) {

        $this->RU = $RU;
        return $this;
    }

    /**
     * Get customer email.
     * @return String
     */
    public function getEmail()
    {
        return $this->EMAIL;
    }

    /**
     * Set customer email
     * @param String $EMAIL
     * return Besteron
     */
    public function setEmail($EMAIL)
    {
        $this->EMAIL = $EMAIL;
        return $this;
    }


    public function getToken(){
        $url = 'https://gate.besteron.com/api/oauth2/token';
        $data = array('grant_type' =>'client_credentials', 'client_id' => $this->CID,'client_secret' => $this->KEY);
        $options = array(
                'http' => array(
                'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
                'method'  => 'POST',
                'content' => http_build_query($data),
            )
        );
        $context  = stream_context_create($options);
        $result = file_get_contents($url, false, $context);
        $result = json_decode($result);
        $access_token = $result->access_token;
    }

    public function getTransactionStatus($transactionId){
        $url = 'https://passive.besteron.com/api/oauth2/token';
        $data = array('grant_type' =>'client_credentials', 'client_id' => $this->CID,'client_secret' => $this->KEY);
        $options = array(
                'http' => array(
                'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
                'method'  => 'POST',
                'content' => http_build_query($data),
            )
        );
        $context  = stream_context_create($options);
        $result = file_get_contents($url, false, $context);
        $result = json_decode($result);
        $access_token = $result->access_token;
        $params = [
            $transactionId
        ];

        $ch = curl_init('https://passive.besteron.com/api/payment-intents/'.$transactionId);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
           'Content-Type: application/json',
           'Accept: application/json',
           'Authorization: Bearer ' . $access_token
           ));
        curl_setopt($ch, CURLOPT_POSTFIELDS, null);
        $result = curl_exec($ch);
        $result = json_decode($result);
        curl_close($ch);
        return $result->transaction->status;
    }

    public function getUrl($TYPE, $USED_BANKS, $ORDER, $CART,$bankarray,$inline_payment_type) {

        if($inline_payment_type != 'CARD'){
            $thebank = $TYPE;
            if($TYPE == 'SPOROCARD'){
                $TYPE = 'CARD';
            }
            $bankarray = [];
            $bankarray[] = $TYPE;
            if($TYPE=='CARD'){
                $bankarray[] = 'APPLEPAY';
                $bankarray[] = 'GOOGLEPAY';
            }
        }
        $this->TYPE = $TYPE;
        // language for Besteron gateway
        // get Besteron language from parameter
        $lang_best = $this->LANG;
      
        // auto language
        if ( 'wp_auto' === $lang_best ) {
            // get language from WP locale
            list( $lang_best ) = explode( '_', get_locale(), 2 );
            if ( 'cs' === $lang_best ) {
                // repair CZ language
                $lang_best = 'cs';
            }
        }
        $lang_best = strtoupper($lang_best);
        $url = 'https://gate.besteron.com/api/oauth2/token';
        $data = array('grant_type' =>'client_credentials', 'client_id' => $this->CID,'client_secret' => $this->KEY);
        $options = array(
                'http' => array(
                'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
                'method'  => 'POST',
                'content' => http_build_query($data),
            )
        );
        $context  = stream_context_create($options);
        $result = file_get_contents($url, false, $context);
        $result = json_decode($result);
        $access_token = $result->access_token;
        $items = [];
        $additionalParams = "";
        $additionalParams = [
            'name' => 'woocommerce',
            'value' => '1.2.7'
        ];
    
        if($additionalParams == ""){
            $params = array(
                'totalAmount' => number_format($this->AMNT*100,0,'',''),
                'currencyCode' => $this->getCurr(),
                'orderNumber' => $this->VS,
                'validityTime'=> $this->getValidityTime(),
                'language' => $lang_best,
                'paymentMethods' => $bankarray,
                'items' => $this->formArrayItems($ORDER),
                'callback' => [
                    'returnUrl' => $this->RU,
                    'notificationUrl'=>$this->RU,
                ],
                'buyer'=> $this->formBuyer($ORDER),      
            );
        }
        else{
             $params = array(
                'totalAmount' => number_format($this->AMNT*100,0,'',''),
                'currencyCode' => $this->getCurr(),
                'orderNumber' => $this->VS,
                'validityTime'=> $this->getValidityTime(),
                'language' => $lang_best,
                'paymentMethods' => $bankarray,
                'additionalParams' => [$additionalParams],
                'items' => $this->formArrayItems($ORDER),
                'callback' => [
                    'returnUrl' => $this->RU,
                    'notificationUrl'=>$this->RU,
                ],
                'buyer'=> $this->formBuyer($ORDER),      
            );
        }
        $ch = curl_init('https://gate.besteron.com/api/payment-intent');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
           'Content-Type: application/json',
           'Authorization: Bearer ' . $access_token
           ));
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
        
        $result = curl_exec($ch);

        $result = json_decode($result);

        curl_close($ch);
        if(isset($result->redirectUrl)){
            return $result->redirectUrl;
        }
        else{
            $itemsAr = [];
            $itemArray = [
                'name'=> 'Úhrada objednávky',
                'type'=>'ITEM',
                'amount'=> number_format($this->AMNT*100,0,'',''),
                'count'=> 1,   
            ];

            $itemsAr[] = $itemArray;

            $params = array(
                'totalAmount' => number_format($this->AMNT*100,0,'',''),
                'currencyCode' => $this->getCurr(),
                'orderNumber' => $this->VS,
                'validityTime'=> $this->getValidityTime(),
                'language' => $lang_best,
                'paymentMethods' => $bankarray,
                'items' => $itemsAr,
                'callback' => [
                    'returnUrl' => $this->RU,
                    'notificationUrl'=>$this->RU,
                ],
                'buyer'=> [
                    'email'=>strtolower($ORDER->get_billing_email()),
                ],
            );
            $ch = curl_init('https://gate.besteron.com/api/payment-intent');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
               'Content-Type: application/json',
               'Authorization: Bearer ' . $access_token
               ));
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
            $result = curl_exec($ch);
            $result = json_decode($result);
            curl_close($ch);
          
            return $result->redirectUrl;
        }
    }

   public function formBuyer($order){

        $billing_firstName = $order->get_billing_first_name();
        $billing_lastName = $order->get_billing_last_name();
        $billing_email = $order->get_billing_email();
        $billing_postalCode = $order->get_billing_postcode();
        $billing_address_1 = $order->get_billing_address_1();
        $billing_address_2 = $order->get_billing_address_2();
        $billing_city = $order->get_billing_city();
        $billing_countryCode = $order->get_billing_country();
        $shipping_address_1 = $order->get_shipping_address_1();
        $shipping_address_2 = $order->get_shipping_address_2();
        $shipping_postcode = $order->get_shipping_postcode();
        $shipping_city = $order->get_shipping_city();
        $shipping_country = $order->get_shipping_country();
        $shipping_firstName = $order->get_shipping_first_name();
        $shipping_lastName = $order->get_shipping_first_name();
        $buyer = [];
        if($billing_firstName!=null && $billing_firstName!=""){
            $buyer['firstName'] = substr($billing_firstName,0,128);
        }
        if($billing_lastName!=null && $billing_lastName!=""){
            $buyer['lastName'] = substr($billing_lastName,0,128);
        }
        if($billing_email!=null && $billing_email!=""){
            $buyer['email'] = strtolower($billing_email);
        }
        if(!( ($billing_firstName == null || $billing_firstName == "") && ($billing_lastName == null || $billing_lastName == "") && 
            ($billing_postalCode == null || $billing_postalCode == "") && ($billing_address_1 == null || $billing_address_1 == "") && ($billing_address_2 == null || $billing_address_2 == "") && ($billing_email == null || $billing_email == "") && ($billing_city == null || $billing_city == "") && ($billing_countryCode == null || $billing_countryCode == "")
         ) ){
            $billingArray = [];
            if($billing_firstName!=null && $billing_firstName!=""){
                $billingArray['firstName'] = substr($billing_firstName,0,128);
            }
            if($billing_lastName!=null && $billing_lastName!=""){
                $billingArray['lastName'] = substr($billing_lastName,0,128);
            }
            if($billing_postalCode!=null && $billing_postalCode!=""){
                $billingArray['postalCode'] = substr($billing_postalCode,0, 16);
            }
            if($billing_email!=null && $billing_email!=""){
                $billingArray['email'] = strtolower($billing_email);
            }
            if($billing_address_1!=null && $billing_address_1!=""){
                $billingArray['streetLines'] = [
                    substr($billing_address_1,0,128),
                    substr($billing_address_2,0,128)
                ];
            }
            if($billing_city!=null && $billing_city!=""){
                $billingArray['city'] = substr($billing_city,0,64);
            }
            if($billing_countryCode!=null && $billing_countryCode!="" && strlen($billing_countryCode) == 2){
                $billingArray['countryCode'] = strtoupper($billing_countryCode);
            }
            $buyer['billing'] = $billingArray;
        }
        if(!( ($shipping_address_1 == null || $shipping_address_1 == "") && ($shipping_address_2 == null || $shipping_address_2 == "") && ($shipping_postcode == null || $shipping_postcode == "") && ($shipping_city == null || $shipping_city == "") && ($shipping_country == null || $shipping_country == "") && ($shipping_firstName == null || $shipping_firstName == "") && ($shipping_lastName == null || $shipping_lastName == "")) ){
             if( $order->has_shipping_address() ){
                $delivery = [];
                if($shipping_address_1!=null && $shipping_address_1!=""){
                    $delivery['streetLines'] = [
                        substr($shipping_address_1,0,128),
                        substr($shipping_address_2,0,128)
                    ];
                }
                if($shipping_postcode!=null && $shipping_postcode!=""){
                    $delivery['postalCode'] = substr($shipping_postcode,0,16);
                }
                if($shipping_city!=null && $shipping_city!=""){
                    $delivery['city'] = substr($shipping_city,0,64);
                }
                if($shipping_country!=null && $shipping_country!="" && strlen($shipping_country) == 2){
                    $delivery['countryCode'] = strtoupper($shipping_country);
                }
                if($shipping_firstName!="" && $shipping_firstName!=null){
                    $delivery['recipient']['firstName'] = substr($shipping_firstName,0,128);
                }
                if($shipping_lastName!="" && $shipping_lastName!=null){
                    $delivery['recipient']['lastName'] = substr($shipping_lastName,0,128);
                }
                if($billing_email!="" && $billing_email!=null){
                    $delivery['recipient']['email'] = strtolower($billing_email);
                }
                $buyer['delivery'] = $delivery;
             }
        }
        return $buyer;
    }
    public function formArrayItems($order){
        $items = $order->get_items();
        $itemsAr = [];
        $sucet = 0;
        foreach( $items as $item ){
            $product = wc_get_product($item->get_product_id());
            $tax_rates = WC_Tax::get_rates( $product->get_tax_class() );
            $tax = 0;
            foreach ($tax_rates as $tax_rate) {
                $tax = $tax_rate['rate'];
            }

            $sku = "";

            if($product->get_sku()!=null){
                $sku = $product->get_sku();

                $quantity = $item->get_quantity();

                if($quantity == "" || $quantity == null){
                    $quantity = 1;
                }


                $sucet = $sucet + (number_format( ( ($item->get_subtotal() + $item->get_subtotal_tax() ) / $quantity)  * 100 ,0,'','') * $quantity);


                 $itemArray = [
                    'name'=> substr($item->get_name(),0,128),
                    'type'=>'ITEM',
                    'amount'=> number_format( ( ($item->get_subtotal() + $item->get_subtotal_tax() ) / $quantity)  * 100 ,0,'',''),
                    'count'=> $quantity,
                    'vatRate'=>$tax,
               //     'EAN'=>substr($sku,0,64), 
                ];

            }
            else{

                $quantity = $item->get_quantity();

                if($quantity == "" || $quantity == null){
                    $quantity = 1;
                }

                $sucet = $sucet + (number_format( ( ($item->get_subtotal() + $item->get_subtotal_tax() ) / $quantity)  * 100 ,0,'','') * $quantity);

               

                 $itemArray = [
                    'name'=> substr($item->get_name(),0,128),
                    'type'=>'ITEM',
                    'amount'=> number_format( ( ($item->get_subtotal() + $item->get_subtotal_tax() ) / $quantity)  * 100,0,'',''),
                    'count'=> $quantity,
                    'vatRate'=>$tax,
                ];

            }

           
            $itemsAr[] = $itemArray;


        }

        foreach( $order->get_items( 'shipping' ) as $item_id => $item ){
            $order_item_name             = $item->get_name();
            $order_item_type             = $item->get_type();
            $shipping_method_title       = $item->get_method_title();
            $shipping_method_id          = $item->get_method_id(); // The method ID
            $shipping_method_instance_id = $item->get_instance_id(); // The instance ID
            $shipping_method_total       = $item->get_total();
            $shipping_method_total_tax   = $item->get_total_tax();
            $shipping_method_taxes       = $item->get_taxes();



            $tax_rates = WC_Tax::get_rates( $item->get_tax_class() );
            $tax = 0;

            foreach ($tax_rates as $tax_rate) {
                $tax = $tax_rate['rate'];
            }

            $sucet = $sucet + number_format(( (number_format(  ( ($item->get_total() + $item->get_total_tax() ))  ,2,'.',''))  ) * 100,0,'','');


             $itemArray = [
                    'name'=> substr($item->get_name(),0,128),
                    'type'=>'DELIVERY',
                    'amount'=>number_format(( (number_format(  ( ($item->get_total() + $item->get_total_tax() ))  ,2,'.',''))  ) * 100,0,'',''),
                    'count'=> 1,
                    'vatRate'=>$tax,
                ];

                 $itemsAr[] = $itemArray;

        }


        $coupons = $order->get_coupons();

        foreach ($coupons as $item) {

            $tax_rates = WC_Tax::get_rates( $item->get_tax_class() );
            $tax = 0;

            foreach ($tax_rates as $tax_rate) {
                $tax = $tax_rate['rate'];
            }

            $sucet = $sucet - number_format(( (number_format(  ( ($item->get_discount() + $item->get_discount_tax() ))  ,2,'.',''))  ) * 100,0,'','');


            $itemArray = [
                    'name'=> substr($item->get_name(),0,128),
                    'type'=>'COUPON',
                    'amount'=>number_format(( (number_format(  ( ($item->get_discount() + $item->get_discount_tax() ))  ,2,'.',''))  ) * 100,0,'',''),
                    'count'=> 1,
                    'vatRate'=>$tax,
                ];

                 $itemsAr[] = $itemArray;
        }


        if(number_format($sucet,0,'','') == number_format($this->AMNT*100,0,'','')) {
            return $itemsAr;
        }
        else{

            $itemsAr = [];

            $itemArray = [
                    'name'=> 'Úhrada objednávky',
                    'type'=>'ITEM',
                    'amount'=> number_format($this->AMNT*100,0,'',''),
                    'count'=> 1,
                   
                ];

                $itemsAr[] = $itemArray;

                return $itemsAr;


        }


        
    }

    public function getGeneratorUrl() {

        $params = array(
            'cid=' . $this->CID,
            'amnt=' . $this->AMNT,
            'curr=' . $this->CURR,
            'vs=' . $this->VS,
            'ru=' . urlencode($this->RU),
            'email=' . urlencode($this->EMAIL),
            'sign=' . $this->generateSign($this->getString(false))
        );

        $url = $this->BESTERON_PAYMENTS_GATEWAYS_GENERATOR_URL . '?' . implode('&', $params);
        return $url;
    }

    /**
     * Return string for hash to sign.
     * @var String
     */
    public function getString($type = true) {

        $string = $this->CID . ($type ? $this->TYPE : '') . $this->AMNT . $this->CURR . $this->VS . $this->RU;

        return $string;
    }

}

class BesteronResponse extends Besteron {

    /**
     * Status. Required
     * @var String
     */
    protected $RESULT;

    /**
     * Sign from besteron.
     * @var String
     */
    protected $SIGN;

    /**
     * @return Besteron
     */
    public function __construct($options = array(), $cfgPath = '') {

        parent::__construct($options, $cfgPath);

        if (!isset($options[self::PARAM_TYPE])) {
            throw new Exception('TYPE is not defined.');
        }
        if (empty($options[self::PARAM_TYPE])) {
            throw new Exception('TYPE code is empty.');
        }
        if (!isset($options[self::PARAM_AMNT])) {
            throw new Exception('Amount is not defined.');
        }
        if (empty($options[self::PARAM_AMNT])) {
            throw new Exception('Amount is empty.');
        }
        if (!isset($options[self::PARAM_CURR])) {
            throw new Exception('Currency is not defined.');
        }
        if (empty($options[self::PARAM_CURR])) {
            throw new Exception('Currency is empty.');
        }
        if (!isset($options[self::PARAM_VS])) {
            throw new Exception('VariableSymbol is not defined.');
        }
        if (!isset($options[self::PARAM_VS])) {
            throw new Exception('VariableSymbol is empty.');
        }
        if (!is_numeric($options[self::PARAM_VS])) {
            throw new Exception('VariableSymbol is not numeric.');
        }
        if (strlen($options[self::PARAM_VS]) > 10) {
            throw new Exception('VariableSymbol max length is 10.');
        }
        if (!isset($options[self::PARAM_RESULT])) {
            throw new Exception('Result is not defined.');
        }
        if (empty($options[self::PARAM_RESULT])) {
            throw new Exception('Result is empty.');
        }
        if (!isset($options[self::PARAM_SIGN])) {
            throw new Exception('Sign is not defined.');
        }
        if (empty($options[self::PARAM_SIGN])) {
            throw new Exception('Sign is empty.');
        }

        $this->TYPE = $options[self::PARAM_TYPE];
        $this->AMNT = $options[self::PARAM_AMNT];
        $this->CURR = $options[self::PARAM_CURR];
        $this->VS = $options[self::PARAM_VS];
        $this->RESULT = $options[self::PARAM_RESULT];
        $this->SIGN = $options[self::PARAM_SIGN];

        return $this;
    }

    /**
     * Get result
     * @return string
     */
    public function getResult() {
        return $this->RESULT;
    }

    /**
     * Set result.
     * @param string $result
     * @return string
     */
    public function setResult($RESULT) {
        $this->RESULT = $RESULT;
        return $this;
    }

    /**
     * Return sign.
     * @return string
     */
    public function getSign() {

        return $this->SIGN;
    }

    /**
     * Set sign.
     * @param string $sign
     * @return Besteron
     */
    public function setSign($SIGN) {

        $this->SIGN = $SIGN;
        return $this;
    }

    /**
     * Generate string for generetaSign();
     * @return string
     */
    public function getString() {

        $string = $this->CID . $this->TYPE . $this->AMNT . $this->CURR . $this->VS . $this->RESULT;
        return $string;
    }

    public function isValid() {

        return $this->generateSign($this->getString()) == $this->SIGN;
    }

}
